﻿Imports System
Imports System.IO
Public Class imagelist
    Inherits System.Web.UI.Page
    Public il As String = String.Empty

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Response.Expires = 0
        Dim ImgFolder As String()
        Dim fldr As String = "banner"
        If Request("folder") IsNot Nothing Then fldr = Request("folder")
        Dim mylog As String = Request("uname")
        If String.IsNullOrEmpty(mylog) Then mylog = "banner"
        ImgFolder = ImageFilesList(fldr, mylog)
        If Request("cmnd") = "del" Then ImgFolder = RemoveFile(ImgFolder, fldr, Request("fln"), mylog)
        For i = 0 To ImgFolder.Length - 1
            il &= ImgFolder(i) & ","
        Next
        il = il.Trim(",")
        Select Case fldr
            Case "banner"
                ImageListBox.Controls.Add(BannerTable(ImgFolder))
            Case Else
                ImageListBox.Controls.Add(ImageTable(fldr, ImgFolder))
        End Select
    End Sub
    Function ImageTable(ByVal fldr As String, ByVal imglist() As String) As HtmlTable
        Dim it As New HtmlTable
        it.CellSpacing = "5"
        it.CellPadding = "3"
        it.Width = "380"
        it.Border = "1"
        it.BgColor = "beige"
        Dim itr As New HtmlTableRow
        Dim cll As Integer = 0
        Dim itc As New HtmlTableCell
        For i = 0 To UBound(imglist)
            If Trim(imglist(i)).Length > 0 Then
                itc = New HtmlTableCell
                itc.BgColor = "white"
                itc.Align = "center"
                Dim bi As New HtmlImage
                bi.Src = "images/"
                If Not fldr = "picture" Then bi.Src &= fldr & "/"
                bi.Src &= imglist(i)
                bi.Alt = imglist(i)
                bi.Width = "100"
                bi.Attributes.Add("onclick", "window.external.SelectBanner('" & imglist(i) & "')")
                bi.Attributes.Add("onmouseover", "style.cursor='pointer'")
                itc.Controls.Add(bi)
                itr.Cells.Add(itc)
                cll += 1
                If cll = 3 Then
                    it.Rows.Add(itr)
                    itr = New HtmlTableRow
                    cll = 0
                End If
            End If
        Next
        If cll < 3 Then
            For i = 1 To 3 - cll
                itc = New HtmlTableCell
                itr.Cells.Add(itc)
            Next
            it.Rows.Add(itr)
        End If
        Return it
    End Function
    Function BannerTable(ByVal bnnrlst() As String) As HtmlTable
        Dim bt As New HtmlTable
        bt.CellSpacing = "5"
        bt.CellPadding = "3"
        bt.Width = "380"
        bt.Border = "1"
        bt.BgColor = "beige"
        For i = 0 To UBound(bnnrlst)
            If Trim(bnnrlst(i)).Length > 0 Then
                Dim btr As New HtmlTableRow
                Dim btc As New HtmlTableCell
                btc.BgColor = "white"
                btc.Align = "center"
                btc.InnerText = bnnrlst(i)
                btr.Cells.Add(btc)
                bt.Rows.Add(btr)
                btr = New HtmlTableRow
                btc = New HtmlTableCell
                btc.BgColor = "white"
                btc.Align = "center"
                Dim bi As New HtmlImage
                bi.Src = "images/banner/" & bnnrlst(i)
                bi.Alt = bnnrlst(i)
                bi.Width = "350"
                bi.Attributes.Add("onclick", "window.external.SelectBanner('" & bnnrlst(i) & "')")
                bi.Attributes.Add("onmouseover", "style.cursor='pointer'")
                btc.Controls.Add(bi)
                btr.Cells.Add(btc)
                bt.Rows.Add(btr)
            End If
        Next
        Return bt
    End Function

    Function RemoveFile(ByVal imgflst As String(), ByVal folder As String, ByVal img As String, ByVal uname As String) As String()
        Dim imgtmp As String()
        Dim cnt = 0
        ReDim imgtmp(cnt)
        For i = 0 To UBound(imgflst)
            If imgflst(i) = img Then
                Dim fln As String = "~/images/"
                If Not folder = "picture" Then fln &= folder & "/"
                fln = Server.MapPath(fln & imgflst(i))
                File.Delete(fln)
            Else
                ReDim Preserve imgtmp(cnt)
                imgtmp(cnt) = imgflst(i)
                cnt += 1
            End If
        Next
        UpdateFileList(folder, imgtmp, uname)
        Return imgtmp
    End Function

    Function ImageFilesList(ByVal folder As String, ByVal mlog As String) As String()
        Dim cnt As Integer = 0
        Dim imglist(0) As String
        Dim fs As String = "~/images/"
        If Not folder = "picture" Then fs &= folder & "/"
        fs &= mlog & ".txt"
        Try
            Dim filename = Server.MapPath(fs)
            Using sr As StreamReader = New StreamReader(filename)
                Dim tmp As String
                Do
                    tmp = sr.ReadLine()
                    If (tmp Is Nothing) Then Exit Do
                    ReDim Preserve imglist(cnt)
                    imglist(cnt) = tmp
                    cnt += 1
                Loop Until tmp Is Nothing
            End Using
        Catch ex As Exception
            'Return ex.Message
        End Try
        Return imglist
    End Function

    Sub UpdateFileList(ByVal folder As String, ByVal nwfile As String(), ByVal mlog As String)
        Dim filename = "D:\wwwcsroot\MailCenter\images\"
        If Not folder = "picture" Then filename &= folder & "\"
        filename &= mlog & ".txt"
        Dim fso As FileStream = New FileStream(filename, FileMode.Create, FileAccess.Write)
        Dim stream As StreamWriter = New StreamWriter(fso)
        For f = 0 To UBound(nwfile)
            If Trim(nwfile(f)).Length > 0 Then stream.WriteLine(nwfile(f))
        Next
        stream.Close()
        stream = Nothing
        fso = Nothing
    End Sub


End Class