﻿Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel
Imports System
Imports System.IO
Imports System.Data

' To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line.
' <System.Web.Script.Services.ScriptService()> _
<System.Web.Services.WebService(Namespace:="http://mailcenter.cityshakes.com/")> _
<System.Web.Services.WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<ToolboxItem(False)> _
Public Class mcImageHost
    Inherits System.Web.Services.WebService

    <WebMethod()> _
    Public Function CreateMCHost(ByVal MCuName As String) As String
        Dim mcmember As New mcmembers
        'Dim mcuser = mcmember.GetUserInfo(MCuName)
        'If String.IsNullOrEmpty(mcuser(0)) Then
        '    Return "Name Not Found"
        'End If
        Dim fpath As String = Server.MapPath("~/Host/" & MCuName & "/")
        If Not FileIO.FileSystem.DirectoryExists(fpath) Then
            Try
                FileIO.FileSystem.CreateDirectory(fpath)
            Catch ex As Exception
                Return ex.Message
            End Try
            Dim folders() = Split("picture,background,button,logo,line", ",")
            Dim fso As FileStream
            For Each folder As String In folders
                fso = New FileStream(fpath & folder & ".txt", FileMode.Create, FileAccess.Write)
            Next
            fso = Nothing
            Return "ok"
        Else
            Return "Directory Exist."
        End If
    End Function

    <WebMethod()> _
    Public Function GetMailStatus(ByVal username As String, ByVal mailID As String) As DataSet
        Dim gms As New DataSet
        gms.Tables.Add("MailStatus")
        Dim colnames As String() = Split("SenderName,MailID,EmailAddress,RepIP,DateID,TimeID", ",")
        For Each colname As String In colnames
            gms.Tables("MailStatus").Columns.Add(colname)
        Next

        Dim fs As String = Server.MapPath("~/MailStatus/" & username & "/MailStatus.txt")
        Try
            Using sr As StreamReader = New StreamReader(fs)
                Dim tmp As String
                Do
                    tmp = sr.ReadLine()
                    If (tmp Is Nothing) Then Exit Do
                    Dim ms() = Split(tmp, "~")
                    If ms(1) = mailID Then
                        Dim orw As DataRow = gms.Tables("MailStatus").NewRow
                        orw.BeginEdit()
                        orw(0) = ms(0)
                        orw(1) = ms(1)
                        orw(2) = ms(2)
                        orw(3) = ms(3)
                        orw(4) = ms(4)
                        orw(5) = ms(5)
                        orw.EndEdit()
                        gms.Tables("MailStatus").Rows.Add(orw)
                        gms.Tables("MailStatus").GetChanges()
                    End If
                Loop Until tmp Is Nothing
            End Using
        Catch ex As Exception
            Return Nothing
        End Try
        Return gms
    End Function
    <WebMethod()> _
    Public Function GetUnSubscribe(ByVal username As String) As DataSet
        Dim gms As New DataSet
        gms.Tables.Add("Unsubscribe")
        Dim colnames As String() = Split("SenderName,MailID,EmailAddress,RepIP,DateID,TimeID", ",")
        For Each colname As String In colnames
            gms.Tables("Unsubscribe").Columns.Add(colname)
        Next

        Dim fs As String = Server.MapPath("~/MailStatus/" & username & "/Unsubscribe.txt")
        Try
            Using sr As StreamReader = New StreamReader(fs)
                Dim tmp As String
                Do
                    tmp = sr.ReadLine()
                    If (tmp Is Nothing) Then Exit Do
                    Dim ms() = Split(tmp, "~")
                    Dim orw As DataRow = gms.Tables("Unsubscribe").NewRow
                    orw.BeginEdit()
                    orw(0) = ms(0)
                    orw(1) = ms(1)
                    orw(2) = ms(2)
                    orw(3) = ms(3)
                    orw(4) = ms(4)
                    orw(5) = ms(5)
                    orw.EndEdit()
                    gms.Tables("Unsubscribe").Rows.Add(orw)
                    gms.Tables("Unsubscribe").GetChanges()
                Loop Until tmp Is Nothing
            End Using
        Catch ex As Exception
            Return Nothing
        End Try
        Return gms
    End Function
    <WebMethod()> _
    Public Function TryMCHost() As String
        Return "ok"
    End Function

End Class